﻿
#include "pch.h"
#include "framework.h"
#include "cEIP MotionControl Example.h"
#include "cEIP MotionControl ExampleDlg.h"
#include "afxdialogex.h"
#include <string>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#include "Comizoa API/ceSDK.h"
#include "Comizoa API/ceSDKDef.h"


#pragma region MFC_기본코드

#define GUI_Refresh_Timer 0
// 응용 프로그램 정보에 사용되는 CAboutDlg 대화 상자입니다.

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

	// 대화 상자 데이터입니다.
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 지원입니다.

// 구현입니다.
protected:
	DECLARE_MESSAGE_MAP()
public:
	
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{

}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
	
END_MESSAGE_MAP()


// CcEIPMotionControlExampleDlg 대화 상자



CcEIPMotionControlExampleDlg::CcEIPMotionControlExampleDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_CEIP_MOTIONCONTROL_EXAMPLE_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CcEIPMotionControlExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, _CB_Axis, CB_Control_Axis);
	DDX_Control(pDX, _CB_AlarmLogic, CB_AlarmLogic);
	DDX_Control(pDX, _CB_AlarmStop, CB_AlarmStop);
	DDX_Control(pDX, _CB_EL_Logic, CB_EL_Logic);
	DDX_Control(pDX, _CB_EL_Stop, CB_EL_Stop);
	DDX_Control(pDX, _CB_EZLogic, CB_ORGLogic);
	DDX_Control(pDX, _CB_ServoInputLogic, CB_ServoInputLogic);
	DDX_Control(pDX, _CB_EncoderFeedback, CB_EncoderFeedback);
	DDX_Control(pDX, _CB_CommandPulseMode, CB_CommandPulseMode);
	DDX_Control(pDX, _CB_SxSpeedMode, CB_SxSpeedMode);
	DDX_Control(pDX, _CB_HomeMode, CB_HomeMode);
	DDX_Control(pDX, _CB_HomeSpeedMode, CB_HomeSpeedMode);
	DDX_Control(pDX, _CB_HomeDir, CB_HomeDir);
	DDX_Control(pDX, _LB_CMD_Pos, LB_CMD_Pos);
	DDX_Control(pDX, _LB_FB_Pos, LB_FB_Pos);
	DDX_Control(pDX, _LB_CMD_Spd, LB_CMD_Spd);
	DDX_Control(pDX, _LB_FB_Spd, LB_FB_Spd);
	DDX_Control(pDX, _LB_MotState, LB_MotState);
	DDX_Control(pDX, _PC_ALM, PC_ALM);
	DDX_Control(pDX, _PC_NEL, PC_NEL);
	DDX_Control(pDX, _PC_PEL, PC_PEL);
	DDX_Control(pDX, _PC_ORG, PC_ORG);
	DDX_Control(pDX, _PC_INP, PC_INP);
	DDX_Control(pDX, _PC_RDY, PC_RDY);
	DDX_Control(pDX, _PC_LTC, PC_LTC);
	DDX_Control(pDX, _PC_SD, PC_SD);
	DDX_Control(pDX, _TB_SxWorkSpeed, TB_SxWorkSpeed);
	DDX_Control(pDX, _TB_InitSpeed, TB_InitSpeed);
	DDX_Control(pDX, _TB_SxAccel, TB_SxAccel);
	DDX_Control(pDX, _TB_Decel, TB_Decel);
	DDX_Control(pDX, _TB_AbsolutePos1, TB_AbsolutePos1);
	DDX_Control(pDX, _TB_AbsolutePos2, TB_AbsolutePos2);
	DDX_Control(pDX, _TB_RelativePos, TB_RelativePos);
	DDX_Control(pDX, _TB_HomeSpeed, TB_HomeSpeed);
	DDX_Control(pDX, _TB_HomeAccel, TB_HomeAccel);
	DDX_Control(pDX, _TB_HomeDecel, TB_HomeDecel);
	DDX_Control(pDX, _TB_HomeEzCount, TB_HomeEzCount);
	DDX_Control(pDX, _TB_HomeOffset, TB_HomeOffset);
	DDX_Control(pDX, _TB_HomeReverseVel, TB_HomeReverseVel);
	DDX_Control(pDX, _TB_HomeEscapeDist, TB_HomeEscapeDist);
	DDX_Control(pDX, _RB_VelocityMode, RB_VelocityMode);
	DDX_Control(pDX, _RB_AbsoluteMode, RB_AbsoluteMode);
	DDX_Control(pDX, _RB_RelativeMode, RB_RelativeMode);
	DDX_Control(pDX, _BT_SERVO_ONOFF, BT_SERVO_ONOFF);
	DDX_Control(pDX, IDC_CHECK0, check0);
	DDX_Control(pDX, IDC_CHECK1, check1);
	DDX_Control(pDX, IDC_CHECK2, check2);
	DDX_Control(pDX, IDC_CHECK3, check3);
	DDX_Control(pDX, IDC_CHECK4, check4);
	DDX_Control(pDX, IDC_CHECK5, check5);
	DDX_Control(pDX, IDC_CHECK6, check6);
	DDX_Control(pDX, IDC_CHECK7, check7);
	DDX_Control(pDX, IDC_CHECK8, check8);
	DDX_Control(pDX, IDC_CHECK9, check9);
	DDX_Control(pDX, IDC_CHECK10, check10);
	DDX_Control(pDX, IDC_CHECK11, check11);
	DDX_Control(pDX, IDC_CHECK12, check12);
	DDX_Control(pDX, IDC_CHECK13, check13);
	DDX_Control(pDX, IDC_CHECK14, check14);
	DDX_Control(pDX, IDC_CHECK15, check15);
	DDX_Control(pDX, CB_ALM, ALM_check);
	DDX_Control(pDX, CB_EL_minus, ELminus_check);
	DDX_Control(pDX, CB_EL_plus, ELplus_check);
	DDX_Control(pDX, CB_org, ORG_check);
	DDX_Control(pDX, CB_INP, INP_check);
	DDX_Control(pDX, CB_RDY, RDY_check);
	DDX_Control(pDX, CB_LTC, LTC_check);
	DDX_Control(pDX, CB_SD, SD_check);
}

BEGIN_MESSAGE_MAP(CcEIPMotionControlExampleDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(BT_Init, &CcEIPMotionControlExampleDlg::OnBnClickedInit)
	ON_WM_CLOSE()
	ON_BN_CLICKED(_BT_SERVO_ONOFF, &CcEIPMotionControlExampleDlg::OnBnClickedBtServoOnoff)
	ON_BN_CLICKED(BT_ResetPos, &CcEIPMotionControlExampleDlg::OnBnClickedResetpos)
	ON_BN_CLICKED(BT_ResetAlarm, &CcEIPMotionControlExampleDlg::OnBnClickedResetalarm)
	ON_BN_CLICKED(BT_Apply_Logic, &CcEIPMotionControlExampleDlg::OnBnClickedApplyLogic)
	ON_BN_CLICKED(BT_Apply_Speed, &CcEIPMotionControlExampleDlg::OnBnClickedApplySpeed)
	ON_BN_CLICKED(BT_SxMove_N, &CcEIPMotionControlExampleDlg::OnBnClickedSxmoveN)
	ON_BN_CLICKED(BT_SxMove_P, &CcEIPMotionControlExampleDlg::OnBnClickedSxmoveP)
	ON_BN_CLICKED(BT_SxStop, &CcEIPMotionControlExampleDlg::OnBnClickedSxstop)
	ON_BN_CLICKED(BT_SxEMGStop, &CcEIPMotionControlExampleDlg::OnBnClickedSxemgstop)
	ON_BN_CLICKED(BT_SxStop2, &CcEIPMotionControlExampleDlg::OnBnClickedSxstop2)
	ON_BN_CLICKED(BT_SxEMGStop2, &CcEIPMotionControlExampleDlg::OnBnClickedSxemgstop2)
	ON_BN_CLICKED(BT_Apply_Home, &CcEIPMotionControlExampleDlg::OnBnClickedApplyHome)
	ON_BN_CLICKED(BT_HomeMove, &CcEIPMotionControlExampleDlg::OnBnClickedHomemove)
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(_CB_Axis, &CcEIPMotionControlExampleDlg::OnCbnSelchangeCbAxis)
	ON_BN_CLICKED(IDC_BUTTON2, &CcEIPMotionControlExampleDlg::DIDO_OFF)
	ON_BN_CLICKED(DIO_ON, &CcEIPMotionControlExampleDlg::DIDO_ON)
	ON_STN_CLICKED(_PC_ALM, &CcEIPMotionControlExampleDlg::OnStnClickedPcAlm)
	ON_CBN_SELCHANGE(_CB_AlarmLogic, &CcEIPMotionControlExampleDlg::OnCbnSelchangeCbAlarmlogic)
	ON_BN_CLICKED(Logic_A, &CcEIPMotionControlExampleDlg::OnBnClickLogic_A)
	ON_BN_CLICKED(Logic_B, &CcEIPMotionControlExampleDlg::OnBnClickLogic_B)

END_MESSAGE_MAP()


// CcEIPMotionControlExampleDlg 메시지 처리기

BOOL CcEIPMotionControlExampleDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// 시스템 메뉴에 "정보..." 메뉴 항목을 추가합니다.

	// IDM_ABOUTBOX는 시스템 명령 범위에 있어야 합니다.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// 이 대화 상자의 아이콘을 설정합니다.  응용 프로그램의 주 창이 대화 상자가 아닐 경우에는
	//  프레임워크가 이 작업을 자동으로 수행합니다.
	SetIcon(m_hIcon, TRUE);			// 큰 아이콘을 설정합니다.
	SetIcon(m_hIcon, FALSE);		// 작은 아이콘을 설정합니다.

	// TODO: 여기에 추가 초기화 작업을 추가합니다.
	GUI_Init();

	return TRUE;  // 포커스를 컨트롤에 설정하지 않으면 TRUE를 반환합니다.
}

void CcEIPMotionControlExampleDlg::OnClose()
{
	End_cEIP();
	KillTimer(GUI_Refresh_Timer);
	CDialogEx::OnClose();
}


void CcEIPMotionControlExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// 대화 상자에 최소화 단추를 추가할 경우 아이콘을 그리려면
//  아래 코드가 필요합니다.  문서/뷰 모델을 사용하는 MFC 애플리케이션의 경우에는
//  프레임워크에서 이 작업을 자동으로 수행합니다.

void CcEIPMotionControlExampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 그리기를 위한 디바이스 컨텍스트입니다.

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// 클라이언트 사각형에서 아이콘을 가운데에 맞춥니다.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 아이콘을 그립니다.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// 사용자가 최소화된 창을 끄는 동안에 커서가 표시되도록 시스템에서
//  이 함수를 호출합니다.
HCURSOR CcEIPMotionControlExampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


#pragma endregion

#pragma region UI관련
void CcEIPMotionControlExampleDlg::GUI_Init()
{
	CB_Control_Axis.SetCurSel(0);
	CB_AlarmLogic.SetCurSel(0);
	CB_AlarmStop.SetCurSel(0);
	CB_CommandPulseMode.SetCurSel(0);
	CB_EL_Logic.SetCurSel(0);
	CB_EL_Stop.SetCurSel(0);
	CB_EncoderFeedback.SetCurSel(0);
	CB_ORGLogic.SetCurSel(0);
	CB_HomeDir.SetCurSel(0);
	CB_HomeMode.SetCurSel(0);
	CB_HomeSpeedMode.SetCurSel(0);
	CB_ServoInputLogic.SetCurSel(0);
	CB_SxSpeedMode.SetCurSel(0);
	RB_VelocityMode.SetCheck(1);
	TB_AbsolutePos1.SetWindowTextA("0");
	TB_AbsolutePos2.SetWindowTextA("10000");
	TB_RelativePos.SetWindowTextA("10000");
}
void CcEIPMotionControlExampleDlg::GUI_Refresh_ServoOnOff()
{
	long Current_Axis = CB_Control_Axis.GetCurSel();
	long IsServoOn = 0;
	cemGnServoOn_Get(Current_Axis, &IsServoOn);

	BT_SERVO_ONOFF.SetWindowTextA(IsServoOn == CE_TRUE ? "Servo On/Off (ON)" : "Servo On/Off (OFF)");
}
void CcEIPMotionControlExampleDlg::GUI_Refresh_Position()
{
	long Current_Axis = CB_Control_Axis.GetCurSel();
	double cmdPos = 0;
	double fdbPos = 0;
	double cmdSpd = 0;
	double fdbSpd = 0;

	cemStPosition_Get(Current_Axis, cemCNT_COMM, &cmdPos);
	cemStPosition_Get(Current_Axis, cemCNT_FEED, &fdbPos);
	cemStSpeed_Get(Current_Axis, cemCNT_COMM, &cmdSpd);
	cemStSpeed_Get(Current_Axis, cemCNT_FEED, &fdbSpd);

	std::string temp;
	
	temp = std::to_string((long double)cmdPos);
	LB_CMD_Pos.SetWindowTextA(temp.c_str());
	temp = std::to_string((long double)fdbPos);
	LB_FB_Pos.SetWindowTextA(temp.c_str());
	temp = std::to_string((long double)cmdSpd);
	LB_CMD_Spd.SetWindowTextA(temp.c_str());
	temp = std::to_string((long double)fdbSpd);
	LB_FB_Spd.SetWindowTextA(temp.c_str());
}
void CcEIPMotionControlExampleDlg::GUI_Refresh_MotState()
{
	long Current_Axis = CB_Control_Axis.GetCurSel();
	long status = 0;
	
	cemStReadMotionState(Current_Axis, &status);
	
	switch (status)
	{
	case cemMST_STOP:
		LB_MotState.SetWindowTextA("Stop");
		break;
	case cemMST_WAIT_DR:
		LB_MotState.SetWindowTextA("WaitDR");
		break;
	case cemMST_WAIT_STA:
		LB_MotState.SetWindowTextA("WaitSTA");
		break;
	case cemMST_WAIT_INSYNC:
		LB_MotState.SetWindowTextA("WaitINSYNC");
		break;
	case cemMST_WAIT_OTHER:
		LB_MotState.SetWindowTextA("WaitOTHER");
		break;
	case cemMST_WAIT_ERC:
		LB_MotState.SetWindowTextA("WaitERC");
		break;
	case cemMST_WAIT_DIR:
		LB_MotState.SetWindowTextA("WaitDIR");
		break;
	case cemMST_WAIT_PLSR:
		LB_MotState.SetWindowTextA("WaitPLSR");
		break;
	case cemMST_IN_RVSSPD:
		LB_MotState.SetWindowTextA("WaitRVSSPD");
		break;
	case cemMST_IN_INISPD:
		LB_MotState.SetWindowTextA("IniSpeed");
		break;
	case cemMST_IN_ACC:
		LB_MotState.SetWindowTextA("InAcceleration");
		break;
	case cemMST_IN_WORKSPD:
		LB_MotState.SetWindowTextA("InWorkspeed");
		break;
	case cemMST_IN_DEC:
		LB_MotState.SetWindowTextA("InDeceleration");
		break;
	case cemMST_WAIT_INP:
		LB_MotState.SetWindowTextA("WaitINP");
		break;
	default:
		std::string temp = std::to_string((long double)status);
		LB_MotState.SetWindowTextA(temp.c_str());
		break;
	}
}
void CcEIPMotionControlExampleDlg::GUI_Refresh_MIOState()
{
	long Current_Axis = CB_Control_Axis.GetCurSel();
	long status = 0;

	cemStReadMioStatuses(Current_Axis, &status);
	/*
	GUI_SetLedState(&PC_ALM, (status >> cemIOST_ALM) & 0x1); // ALM 
	GUI_SetLedState(&PC_NEL, (status >> cemIOST_ELN) & 0x1); // +EL 
	GUI_SetLedState(&PC_PEL, (status >> cemIOST_ELP) & 0x1); // -EL
	GUI_SetLedState(&PC_ORG, (status >> cemIOST_ORG) & 0x1); // ORG
	GUI_SetLedState(&PC_INP, (status >> cemIOST_INP) & 0x1); // INP
	GUI_SetLedState(&PC_RDY, (status >> cemIOST_RDY) & 0x1); // RDY 
	GUI_SetLedState(&PC_LTC, (status >> cemIOST_LTC) & 0x1); // LTC 
	GUI_SetLedState(&PC_SD, (status >> cemIOST_SD) & 0x1); // SD 
	*/

	int ALMchecked = (status >> cemIOST_ALM) & 0x1;
	int NELchecked = (status >> cemIOST_ELN) & 0x1;
	int PELchecked = (status >> cemIOST_ELP) & 0x1;
	int ORGchecked = (status >> cemIOST_ORG) & 0x1;
	int INPchecked = (status >> cemIOST_INP) & 0x1;
	int RDYchecked = (status >> cemIOST_RDY) & 0x1;
	int LTCchecked = (status >> cemIOST_LTC) & 0x1;
	int SDchecked = (status >> cemIOST_SD) & 0x1;

	if (ALMchecked != 0)
	{
		ALM_check.SetCheck(BST_CHECKED);
	}
	else {
		ALM_check.SetCheck(BST_UNCHECKED);
	}
	if (NELchecked != 0)
	{
		ELminus_check.SetCheck(BST_CHECKED);
	}
	else {
		ELminus_check.SetCheck(BST_UNCHECKED);
	}
	if (PELchecked != 0)
	{
		ELplus_check.SetCheck(BST_CHECKED);
	}
	else {
		ELplus_check.SetCheck(BST_UNCHECKED);
	}
	if (ORGchecked != 0)
	{
		ORG_check.SetCheck(BST_CHECKED);
	}
	else {
		ORG_check.SetCheck(BST_UNCHECKED);
	}
	if (INPchecked != 0)
	{
		INP_check.SetCheck(BST_CHECKED);
	}
	else {
		INP_check.SetCheck(BST_UNCHECKED);
	}
	if (RDYchecked != 0)
	{
		RDY_check.SetCheck(BST_CHECKED);
	}
	else {
		RDY_check.SetCheck(BST_UNCHECKED);
	}
	if (LTCchecked != 0)
	{
		LTC_check.SetCheck(BST_CHECKED);
	}
	else {
		LTC_check.SetCheck(BST_UNCHECKED);
	}
	if (SDchecked != 0)
	{
		SD_check.SetCheck(BST_CHECKED);
	}
	else {
		SD_check.SetCheck(BST_UNCHECKED);
	}

}
void CcEIPMotionControlExampleDlg::GUI_Refresh_Logic()
{
	long Current_Axis = CB_Control_Axis.GetCurSel();
	long ALM_Logic = 0;
	long ALM_Mode = 0;
	long EL_Logic = 0;
	long EL_Mode = 0;
	long ORG_Logic = 0;
	long ServoOn_Logic = 0;
	long Encoder_Fdb = 0;
	long Cmd_Pls_Mode = 0;
	long is_reverse = 0;

	cemCfgMioProperty_Get(Current_Axis, cemMPID_ALM_LOGIC, &ALM_Logic);
	cemCfgMioProperty_Get(Current_Axis, cemMPID_ALM_MODE, &ALM_Mode);
	cemCfgMioProperty_Get(Current_Axis, cemMPID_EL_LOGIC, &EL_Logic);
	cemCfgMioProperty_Get(Current_Axis, cemMPID_EL_MODE, &EL_Mode);
	cemCfgMioProperty_Get(Current_Axis, cemMPID_ORG_LOGIC, &ORG_Logic);
	cemCfgMioProperty_Get(Current_Axis, cemMPID_SVON_LOGIC, &ServoOn_Logic);
	cemCfgInMode_Get(Current_Axis, &Encoder_Fdb, &is_reverse);
	cemCfgOutMode_Get(Current_Axis, &Cmd_Pls_Mode);


	CB_AlarmLogic.SetCurSel(ALM_Logic);
	CB_AlarmStop.SetCurSel(ALM_Mode);
	CB_EL_Logic.SetCurSel(EL_Logic);
	CB_EL_Stop.SetCurSel(EL_Mode);
	CB_ORGLogic.SetCurSel(ORG_Logic);
	CB_ServoInputLogic.SetCurSel(ServoOn_Logic);
	CB_EncoderFeedback.SetCurSel(Encoder_Fdb);
	CB_CommandPulseMode.SetCurSel(Cmd_Pls_Mode);

}
void CcEIPMotionControlExampleDlg::GUI_Refresh_SxSpeedSetup()
{
	long Current_Axis = CB_Control_Axis.GetCurSel();
	long SpeedMode = 0;
	double WorkSpeed = 0;
	double Accel = 0;
	double Decel = 0;
	double InitSpeed = 0;
	cemCfgSpeedPattern_Get(Current_Axis, &SpeedMode, &WorkSpeed, &Accel, &Decel);
	cemSxOptIniSpeed_Get(Current_Axis, &InitSpeed);

	CB_SxSpeedMode.SetCurSel(SpeedMode);

	std::string temp;
	temp = std::to_string((long double)WorkSpeed);
	TB_SxWorkSpeed.SetWindowTextA(temp.c_str());
	temp = std::to_string((long double)Accel);
	TB_SxAccel.SetWindowTextA(temp.c_str());
	temp = std::to_string((long double)Decel);
	TB_Decel.SetWindowTextA(temp.c_str());
	temp = std::to_string((long double)InitSpeed);
	TB_InitSpeed.SetWindowTextA(temp.c_str());
}
void CcEIPMotionControlExampleDlg::GUI_Refresh_HomeSetup()
{
	long Current_Axis = CB_Control_Axis.GetCurSel();
	long SpeedMode = 0;
	long HomeMode = 0;
	double WorkSpeed = 0;
	double Accel = 0;
	double Decel = 0;
	long EZCount = 0;
	double Offset = 0;
	double ReverseVel = 0;
	double EscapeDist = 0;
	long Home_Dir = 0;

	cemHomeConfig_Get(Current_Axis, &HomeMode, &Home_Dir, &EZCount, &EscapeDist, &Offset);
	cemHomeSpeedPattern_Get(Current_Axis, &SpeedMode, &WorkSpeed, &Accel, &Decel, &ReverseVel);

	std::string temp;
	temp = std::to_string((long double)EZCount);
	TB_HomeEzCount.SetWindowTextA(temp.c_str());
	temp = std::to_string((long double)EscapeDist);
	TB_HomeEscapeDist.SetWindowTextA(temp.c_str());
	temp = std::to_string((long double)Offset);
	TB_HomeOffset.SetWindowTextA(temp.c_str());
	temp = std::to_string((long double)WorkSpeed);
	TB_HomeSpeed.SetWindowTextA(temp.c_str());
	temp = std::to_string((long double)Accel);
	TB_HomeAccel.SetWindowTextA(temp.c_str());
	temp = std::to_string((long double)Decel);
	TB_HomeDecel.SetWindowTextA(temp.c_str());
	temp = std::to_string((long double)ReverseVel);
	TB_HomeReverseVel.SetWindowTextA(temp.c_str());

	CB_HomeDir.SetCurSel(Home_Dir);
	CB_HomeMode.SetCurSel(WorkSpeed);
	CB_HomeSpeedMode.SetCurSel(SpeedMode);
}

void CcEIPMotionControlExampleDlg::GUI_Refresh_All()
{
	GUI_Refresh_ServoOnOff();
	GUI_Refresh_Position();
	GUI_Refresh_MotState();
	GUI_Refresh_MIOState();
	GUI_Refresh_Logic();
	GUI_Refresh_SxSpeedSetup();
	GUI_Refresh_HomeSetup();
}

void CcEIPMotionControlExampleDlg::GUI_SetLedState(CStatic* nLedId, int nLedState)
{
	CBitmap temp;

	if (nLedState) {
		temp.LoadBitmap(IDB_LedOff);
	}
	else {
		temp.LoadBitmap(IDB_LedRed);
	}

	nLedId->SetBitmap(temp);
	temp.Detach();
}
void CcEIPMotionControlExampleDlg::GUI_Refresh_DIO()
{
	long status = 0;
	cedioMulti_Get(0, 16, &status);
	int checked0 = (status >> 0) & 0x1;
	int checked1 = (status >> 1) & 0x1;
	int checked2 = (status >> 2) & 0x1;
	int checked3 = (status >> 3) & 0x1;
	int checked4 = (status >> 4) & 0x1;
	int checked5 = (status >> 5) & 0x1;
	int checked6 = (status >> 6) & 0x1;
	int checked7 = (status >> 7) & 0x1;
	int checked8 = (status >> 8) & 0x1;
	int checked9 = (status >> 9) & 0x1;
	int checked10 = (status >> 10) & 0x1;
	int checked11 = (status >> 11) & 0x1;
	int checked12 = (status >> 12) & 0x1;
	int checked13 = (status >> 13) & 0x1;
	int checked14 = (status >> 14) & 0x1;
	int checked15 = (status >> 15) & 0x1;


	if (checked0 != 0)
	{
		check0.SetCheck(BST_CHECKED);
	}
	else {
		check0.SetCheck(BST_UNCHECKED);
	}
	if (checked1 != 0)
	{
		check1.SetCheck(BST_CHECKED);
	}
	else {
		check1.SetCheck(BST_UNCHECKED);
	}
	if (checked2 != 0)
	{
		check2.SetCheck(BST_CHECKED);
	}
	else {
		check2.SetCheck(BST_UNCHECKED);
	}
	if (checked3 != 0)
	{
		check3.SetCheck(BST_CHECKED);
	}
	else {
		check3.SetCheck(BST_UNCHECKED);
	}
	if (checked4 != 0)
	{
		check4.SetCheck(BST_CHECKED);
	}
	else {
		check4.SetCheck(BST_UNCHECKED);
	}
	if (checked5 != 0)
	{
		check5.SetCheck(BST_CHECKED);
	}
	else {
		check5.SetCheck(BST_UNCHECKED);
	}
	if (checked6 != 0)
	{
		check6.SetCheck(BST_CHECKED);
	}
	else {
		check6.SetCheck(BST_UNCHECKED);
	}
	if (checked7 != 0)
	{
		check7.SetCheck(BST_CHECKED);
	}
	else {
		check7.SetCheck(BST_UNCHECKED);
	}
	if (checked8 != 0)
	{
		check8.SetCheck(BST_CHECKED);
	}
	else {
		check8.SetCheck(BST_UNCHECKED);
	}
	if (checked9 != 0)
	{
		check9.SetCheck(BST_CHECKED);
	}
	else {
		check9.SetCheck(BST_UNCHECKED);
	}
	if (checked10 != 0)
	{
		check10.SetCheck(BST_CHECKED);
	}
	else {
		check10.SetCheck(BST_UNCHECKED);
	}
	if (checked11 != 0)
	{
		check11.SetCheck(BST_CHECKED);
	}
	else {
		check11.SetCheck(BST_UNCHECKED);
	}
	if (checked12 != 0)
	{
		check12.SetCheck(BST_CHECKED);
	}
	else {
		check12.SetCheck(BST_UNCHECKED);
	}
	if (checked13 != 0)
	{
		check13.SetCheck(BST_CHECKED);
	}
	else {
		check13.SetCheck(BST_UNCHECKED);
	}
	if (checked14 != 0)
	{
		check14.SetCheck(BST_CHECKED);
	}
	else {
		check14.SetCheck(BST_UNCHECKED);
	}
	if (checked15 != 0)
	{
		check15.SetCheck(BST_CHECKED);
	}
	else {
		check15.SetCheck(BST_UNCHECKED);
	}
}

void CcEIPMotionControlExampleDlg::GUI_SetControlAxisInfo()
{
	long NumAxes = 0;
	char Axis_Name[20];

	ceGnTotalMotionChannel(&NumAxes);

	for (int i = 0; i < NumAxes; i++) {
		sprintf_s(Axis_Name, "Axis %d", i);
		CB_Control_Axis.AddString(Axis_Name);
	}
	CB_Control_Axis.SetCurSel(0);
}
#pragma endregion

#pragma region Init관련
void CcEIPMotionControlExampleDlg::Init_cEIP()
{
	ceLoadDll();
	ceGnLoad();
}
bool CcEIPMotionControlExampleDlg::Init_cEIPConnectionCheck()
{

	const long EXPECTED_NODECOUNT = 10;
	const long TIMEOUT = EXPECTED_NODECOUNT * 100;

	long nIsSearchedDev = 0;
	ceGnIsSearchedDevice(&nIsSearchedDev);
	long nNumNodes;

	if (nIsSearchedDev == CE_FALSE)
	{
		ceGnSearchDevice(EXPECTED_NODECOUNT, TIMEOUT, FALSE, &nNumNodes); //노드를 검색합니다.
	}
	else
	{
		ceGnReSearchDevice(EXPECTED_NODECOUNT, TIMEOUT, FALSE, &nNumNodes); //노드를 재검색합니다.
	}

	bool is_OK = (nNumNodes > 0) ? true : false;

	return is_OK;
}
void CcEIPMotionControlExampleDlg::End_cEIP()
{
	ceGnUnload();
	ceUnloadDll();
}
#pragma endregion

#pragma region Control관련
void CcEIPMotionControlExampleDlg::CTRL_Toggle_ServoOn()
{
	long Current_Axis = CB_Control_Axis.GetCurSel();
	long IsServoOn = 0;

	cemGnServoOn_Get(Current_Axis, &IsServoOn);
	cemGnServoOn_Set(Current_Axis, IsServoOn == CE_TRUE ? CE_FALSE : CE_TRUE);
}
void CcEIPMotionControlExampleDlg::CTRL_Pos_Reset()
{
	long Current_Axis = CB_Control_Axis.GetCurSel();

	cemStPosition_Set(Current_Axis, cemCNT_COMM, 0.0);
	cemStPosition_Set(Current_Axis, cemCNT_FEED, 0.0);
}
void CcEIPMotionControlExampleDlg::CTRL_Alarm_Reset()
{
	long Current_Axis = CB_Control_Axis.GetCurSel();
	long Signal_Duration = 10;

	cemGnAlarmReset(Current_Axis, 1);
	Sleep(Signal_Duration);
	cemGnAlarmReset(Current_Axis, 0);
}
void CcEIPMotionControlExampleDlg::CTRL_Apply_MIOLogic()
{
	long Current_Axis = CB_Control_Axis.GetCurSel();
	long ALM_Logic = 0;
	long ALM_Mode = 0;
	long EL_Logic = 0;
	long EL_Mode = 0;
	long ORG_Logic = 0;
	long ServoOn_Logic = 0;
	long Encoder_Fdb = 0;
	long Cmd_Pls_Mode = 0;
	long is_reverse = 0;//Reverse Option은 본 예제에선 무시

	ALM_Logic = CB_AlarmLogic.GetCurSel();
	ALM_Mode = CB_AlarmStop.GetCurSel();
	EL_Logic = CB_EL_Logic.GetCurSel();
	EL_Mode = CB_EL_Stop.GetCurSel();
	ORG_Logic = CB_ORGLogic.GetCurSel();
	ServoOn_Logic = CB_ServoInputLogic.GetCurSel();
	Encoder_Fdb = CB_EncoderFeedback.GetCurSel();
	Cmd_Pls_Mode = CB_CommandPulseMode.GetCurSel();

	cemCfgMioProperty_Set(Current_Axis, cemMPID_ALM_LOGIC, ALM_Logic);
	cemCfgMioProperty_Set(Current_Axis, cemMPID_ALM_MODE, ALM_Mode);
	cemCfgMioProperty_Set(Current_Axis, cemMPID_EL_LOGIC, EL_Logic);
	cemCfgMioProperty_Set(Current_Axis, cemMPID_EL_MODE, EL_Mode);
	cemCfgMioProperty_Set(Current_Axis, cemMPID_ORG_LOGIC, ORG_Logic);
	cemCfgMioProperty_Set(Current_Axis, cemMPID_SVON_LOGIC, ServoOn_Logic);
	cemCfgInMode_Set(Current_Axis, Encoder_Fdb, is_reverse);
	cemCfgOutMode_Set(Current_Axis, Cmd_Pls_Mode);
}
void CcEIPMotionControlExampleDlg::CTRL_Apply_SxSetup()
{
	long Current_Axis = CB_Control_Axis.GetCurSel();
	long SpeedMode = 0;
	double WorkSpeed = 0;
	double Accel = 0;
	double Decel = 0;
	double InitSpeed = 0;

	SpeedMode = CB_SxSpeedMode.GetCurSel();

	CString temp;
	TB_SxWorkSpeed.GetWindowTextA(temp);
	WorkSpeed = _ttoi(temp);
	TB_SxAccel.GetWindowTextA(temp);
	Accel = _ttoi(temp);
	TB_Decel.GetWindowTextA(temp);
	Decel = _ttoi(temp);
	TB_InitSpeed.GetWindowTextA(temp);
	InitSpeed = _ttoi(temp);

	cemCfgSpeedPattern_Set(Current_Axis, SpeedMode, WorkSpeed, Accel, Decel);
	cemSxOptIniSpeed_Set(Current_Axis, InitSpeed);
}
void CcEIPMotionControlExampleDlg::CTRL_Apply_HomeSetup()
{
	long Current_Axis = CB_Control_Axis.GetCurSel();
	long SpeedMode = 0;
	long HomeMode = 0;
	double WorkSpeed = 0;
	double Accel = 0;
	double Decel = 0;
	long EZCount = 0;
	double Offset = 0;
	double ReverseVel = 0;
	double EscapeDist = 0;
	long Home_Dir = 0;


	CString temp;

	TB_HomeEzCount.GetWindowTextA(temp);
	EZCount = _ttoi(temp);
	TB_HomeEscapeDist.GetWindowTextA(temp);
	EscapeDist = _ttoi(temp);
	TB_HomeOffset.GetWindowTextA(temp);
	Offset = _ttoi(temp);
	TB_HomeSpeed.GetWindowTextA(temp);
	WorkSpeed = _ttoi(temp);
	TB_HomeAccel.GetWindowTextA(temp);
	Accel = _ttoi(temp);
	TB_HomeDecel.GetWindowTextA(temp);
	Decel = _ttoi(temp);
	TB_HomeReverseVel.GetWindowTextA(temp);
	ReverseVel = _ttoi(temp);

	Home_Dir = CB_HomeDir.GetCurSel();
	HomeMode = CB_HomeMode.GetCurSel();
	SpeedMode = CB_HomeSpeedMode.GetCurSel();

	cemHomeConfig_Set(Current_Axis, HomeMode, Home_Dir, EZCount, EscapeDist, Offset);
	cemHomeSpeedPattern_Set(Current_Axis, SpeedMode, WorkSpeed, Accel, Decel, ReverseVel);
}
void CcEIPMotionControlExampleDlg::CTRL_VMove(long dir)
{
	long Current_Axis = CB_Control_Axis.GetCurSel();

	cemSxVMoveStart(Current_Axis, dir);
}
void CcEIPMotionControlExampleDlg::CTRL_Relative_Move(long dir)
{
	long Current_Axis = CB_Control_Axis.GetCurSel();
	CString temp;
	double Target_Position_temp;

	TB_RelativePos.GetWindowTextA(temp);
	Target_Position_temp = _ttoi(temp);

	double Target_Position = (dir == cemDIR_P) ? Target_Position_temp : Target_Position_temp * -1;
	cemSxMoveStart(Current_Axis, Target_Position);
}
void CcEIPMotionControlExampleDlg::CTRL_Absolute_Move(long dir)
{
	long Current_Axis = CB_Control_Axis.GetCurSel();
	CString temp;

	if (dir == cemDIR_N) {
		TB_AbsolutePos1.GetWindowTextA(temp);
	}
	else {
		TB_AbsolutePos2.GetWindowTextA(temp);
	}
	double Target_Position = _ttoi(temp);

	cemSxMoveToStart(Current_Axis, Target_Position);
}
void CcEIPMotionControlExampleDlg::CTRL_Homming()
{
	long Current_Axis = CB_Control_Axis.GetCurSel();

	cemHomeMoveStart(Current_Axis);
}
void CcEIPMotionControlExampleDlg::CTRL_Stop()
{
	long Current_Axis = CB_Control_Axis.GetCurSel();

	cemSxStop(Current_Axis, CE_FALSE, CE_FALSE);
}
void CcEIPMotionControlExampleDlg::CTRL_EMGStop()
{
	long Current_Axis = CB_Control_Axis.GetCurSel();

	cemSxStopEmg(Current_Axis);
}

#pragma endregion

#pragma region MFC_Events

void CcEIPMotionControlExampleDlg::OnBnClickedInit()
{
	ceLoadDll();
	ceGnLoad();

	if (Init_cEIPConnectionCheck()) {
		GUI_SetControlAxisInfo();
		GUI_Refresh_All();

		//cedioModeMulti_Set(0, 16, 0xFF);
		SetTimer(GUI_Refresh_Timer, 100, NULL);
	}
}

void CcEIPMotionControlExampleDlg::OnBnClickedBtServoOnoff()
{
	CTRL_Toggle_ServoOn();
	GUI_Refresh_ServoOnOff();
}
void CcEIPMotionControlExampleDlg::OnBnClickedResetpos()
{
	CTRL_Pos_Reset();
}
void CcEIPMotionControlExampleDlg::OnBnClickedResetalarm()
{
	CTRL_Alarm_Reset();
}
void CcEIPMotionControlExampleDlg::OnBnClickedApplyLogic()
{
	CTRL_Apply_MIOLogic();
}
void CcEIPMotionControlExampleDlg::OnBnClickedApplySpeed()
{
	CTRL_Apply_SxSetup();
}


void CcEIPMotionControlExampleDlg::OnBnClickedSxmoveN()
{
	long dir = cemDIR_N;

	if (RB_VelocityMode.GetCheck()) {
		CTRL_VMove(dir);
	}
	else if (RB_RelativeMode.GetCheck()) {
		CTRL_Relative_Move(dir);
	}
	else {
		CTRL_Absolute_Move(dir);
	}
}


void CcEIPMotionControlExampleDlg::OnBnClickedSxmoveP()
{
	long dir = cemDIR_P;

	if (RB_VelocityMode.GetCheck()) {
		CTRL_VMove(dir);
	}
	else if (RB_RelativeMode.GetCheck()) {
		CTRL_Relative_Move(dir);
	}
	else {
		CTRL_Absolute_Move(dir);
	}
}


void CcEIPMotionControlExampleDlg::OnBnClickedSxstop()
{
	CTRL_Stop();
}


void CcEIPMotionControlExampleDlg::OnBnClickedSxemgstop()
{
	CTRL_EMGStop();
}


void CcEIPMotionControlExampleDlg::OnBnClickedSxstop2()
{
	CTRL_Stop();
}


void CcEIPMotionControlExampleDlg::OnBnClickedSxemgstop2()
{
	CTRL_EMGStop();
}


void CcEIPMotionControlExampleDlg::OnBnClickedApplyHome()
{
	CTRL_Apply_HomeSetup();
}


void CcEIPMotionControlExampleDlg::OnBnClickedHomemove()
{
	CTRL_Homming();
}
void CcEIPMotionControlExampleDlg::OnTimer(UINT_PTR nIDEvent)
{
	switch (nIDEvent)
	{
	case GUI_Refresh_Timer:
		GUI_Refresh_MIOState();
		GUI_Refresh_MotState();
		GUI_Refresh_Position();
		GUI_Refresh_ServoOnOff();
		GUI_Refresh_DIO();

		break;
	default:
		break;
	}
	CDialogEx::OnTimer(nIDEvent);
}
void CcEIPMotionControlExampleDlg::OnCbnSelchangeCbAxis()
{
	GUI_Refresh_All();
}
#pragma endregion



void CcEIPMotionControlExampleDlg::DIDO_OFF()
{
	cedioMulti_Put(8, 8, 0);
}


void CcEIPMotionControlExampleDlg::DIDO_ON()
{
	long nDioIniChNot = 0 ;
	long nDioChNum = 15;
	long nDioModeMulti;

	cedioMulti_Put(8, 8, 0xFF);

}



void CcEIPMotionControlExampleDlg::OnBnClickedOn()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
}


void CcEIPMotionControlExampleDlg::OnStnClickedPcAlm()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
}


void CcEIPMotionControlExampleDlg::OnCbnSelchangeCbAlarmlogic()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
}


void CcEIPMotionControlExampleDlg::OnBnClickedButton4()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
}


void CcEIPMotionControlExampleDlg::OnBnClickLogic_A()
{
	cedioLogicMulti_Set(0, 16, 0);

	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
}


void CcEIPMotionControlExampleDlg::OnBnClickLogic_B()
{
	cedioLogicMulti_Set(0, 16, 0xFFFF);
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
}

